<?php

/**
 * Copyright 2024-2025 Simply.IN Sp. z o.o.
 *
 * NOTICE OF LICENSE
 *
 * Licensed under the EUPL-1.2 or later.
 * You may not use this work except in compliance with the Licence.
 *
 * Copy of the Licence is available at:
 * https://joinup.ec.europa.eu/software/page/eupl
 * It is bundled with this package in the file LICENSE.txt
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the Licence is distributed on an as is basis,
 * without warranties or conditions of any kind, either express or implied.
 * Check the Licence for the specific language governing permissions
 * and limitations under the License.
 *
 * @author   Simply.IN Sp. z o.o.
 * @copyright 2024-2025 Simply.IN Sp. z o.o.
 * @license   https://joinup.ec.europa.eu/software/page/eupl
 */

if (!defined('_PS_VERSION_')) {
    exit;
}

class SimplyInOrder extends ObjectModel
{
    use SimplyInInstallSqlTrait;

    public $id;

    public $reference;

    public $simplyin_id;

    public static $token = '';

    public static $definition = [
        'table' => 'simplyin_order',
        'primary' => 'id_simplyin_order',
        'multilang' => false,
        'multilang_shop' => false,
        'fields' => [
            'reference' => [
                'type' => self::TYPE_STRING,
                'size' => 36,
            ],
            'simplyin_id' => [
                'type' => self::TYPE_STRING,
                'size' => 36,
            ],
        ],
    ];

    public static function getByReference($reference)
    {
        $id = Db::getInstance()->getValue('
            SELECT ' . self::$definition['primary'] . '
            FROM `' . _DB_PREFIX_ . self::$definition['table'] . '`
            WHERE reference = "' . pSql($reference) . '"');

        if ($id) {
            return new self((int) $id);
        }
        $object = new self();
        $object->reference = $reference;

        return $object;

    }

    public static function getByIdOrder($id_order)
    {
        $sql = '
            SELECT reference FROM `' . _DB_PREFIX_ . 'orders`
            WHERE id_order = ' . (int) $id_order;
        $reference = Db::getInstance()->getValue($sql);
        if ($reference) {
            return self::getByReference($reference);
        }

        return false;

    }
}
